package ar.com.trabajos.broker.server.service;

import java.math.BigDecimal;
import java.rmi.RemoteException;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;

import javax.xml.rpc.ServiceException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import ar.com.allianz.xmlns.CommonCore.EBM.EBMHeaderType;
import ar.com.allianz.xmlns.CommonCore.EBM.SenderType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.AccesorioVehiculoType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.AdicionalType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.CalcularCotizacionFullVehiculoDataAreaType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.CalcularCotizacionFullVehiculoEBMType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.CalcularCotizacionFullVehiculoResponseEBMType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.CalcularCotizacionFullVehiculoType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.EsquemaComercialType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.UbicacionDelRiesgoType;
import ar.com.allianz.xmlns.Core.EBM.Vehiculo.CotizacionVehiculo.VehiculoACotizarType;
import ar.com.allianz.xmlns.Core.EBO.Allianz.CondicionesContratacion.CondicionesContratacionType;
import ar.com.allianz.xmlns.Core.EBO.Allianz.CotizacionFullVehiculo.CotizacionFullType;
import ar.com.allianz.xmlns.Core.EBS.CotizacionVehiculo.CotizacionVehiculoEBSBindingQSServiceLocator;
import ar.com.trabajos.broker.shared.entities.RequestDTO;
import ar.com.trabajos.broker.shared.entities.ResponseDTO;
import ar.com.trabajos.broker.shared.enums.BrokerEnum;
import ar.com.trabajos.broker.shared.enums.CoberturasEnum;

public class ObtenerCotizacionAllianz implements Cotizador {
	private static Log log = LogFactory.getLog(ObtenerCotizacionAllianz.class);

	
	public ResponseDTO cotizar(RequestDTO input){

		ResponseDTO response=new ResponseDTO();
		response.setBroker(BrokerEnum.ALLIANZ);

		//Allianz

		//vehiculo a cotizar
		String codInfoAuto = input.getCodInfoAuto();
		BigDecimal anoFab = new BigDecimal(input.getModelo());
		BigDecimal precio = new BigDecimal(input.getSumaAsegurada());
		String codigoDeUso = "1";
		String codigoTipoAlarma = "1";
		AccesorioVehiculoType [] listaAccesorios = null ;
		boolean tieneAlarma= false;
		boolean es0Km= false;
		Calendar cal = Calendar.getInstance();
		if (Integer.parseInt(input.getModelo())>=cal.get(Calendar.YEAR))
			es0Km=true;
		else
			es0Km=false;

		//Condiciones contratacion
		String tipoDePoliza = "M";
		String medioDePago = "T";
		BigDecimal cantidadDeCuotas = new BigDecimal(1);
		String codigoCondicionIVA ="1";
		String codigoCondicionIIBB="1";
		BigDecimal clausulaDeAjuste = new BigDecimal(1);
		AdicionalType [] listaAdicionales = null;

		//Ubicacion del riesgo
		String codigoPostal = input.getCodigoPostal();
		String codigoProvincia = "1";

		String codigoDeProductor = "M5842";
		EsquemaComercialType [] listaEsquemasComerciales = null;

		UbicacionDelRiesgoType ubicacionDelRiesgo = new UbicacionDelRiesgoType(codigoPostal, codigoProvincia);
		CondicionesContratacionType condicionesContratacion = new CondicionesContratacionType(tipoDePoliza, medioDePago, cantidadDeCuotas, codigoCondicionIVA, codigoCondicionIIBB, clausulaDeAjuste);
		VehiculoACotizarType vehiculoACotizar = new VehiculoACotizarType(codInfoAuto, anoFab, precio, codigoDeUso, es0Km, tieneAlarma, codigoTipoAlarma, listaAccesorios);
		CalcularCotizacionFullVehiculoDataAreaType dataArea = new CalcularCotizacionFullVehiculoDataAreaType(new CalcularCotizacionFullVehiculoType(codigoDeProductor, vehiculoACotizar, condicionesContratacion, listaAdicionales, ubicacionDelRiesgo, listaEsquemasComerciales));

		String EBMID = "1";
		String userName = "ntnlbrksUser";
		String application = "NationalBrokers";
		String country = "ARG";
		Calendar creationDateTime= Calendar.getInstance();
		String target = "Allianz";
		SenderType sender = new SenderType(userName, application, country);
		EBMHeaderType EBMHeader = new EBMHeaderType(EBMID, creationDateTime, sender, target);
		CalcularCotizacionFullVehiculoEBMType calcularCotizacionFullVehiculoEBM = new CalcularCotizacionFullVehiculoEBMType(EBMHeader, dataArea);
		//fin datos
		Map<String, CoberturasEnum> coberturas = new HashMap<String, CoberturasEnum>();
		coberturas.put("36", CoberturasEnum.RESPONSABILIDAD_CIVIL);
		coberturas.put("37" ,CoberturasEnum.TOTAL_SIN_DANOS_PARCIALES);
		coberturas.put("35" ,CoberturasEnum.TERCEROS_COMPLETOS_FULL);
		coberturas.put("40" ,CoberturasEnum.TODO_RIESGO);
		coberturas.put("79" ,CoberturasEnum.TODO_RIESGO);
		coberturas.put("58" ,CoberturasEnum.TERCEROS_COPMLETOS);
		coberturas.put("77" ,CoberturasEnum.TODO_RIESGO);
		coberturas.put("79" ,CoberturasEnum.TODO_RIESGO);
		coberturas.put("73" ,CoberturasEnum.TODO_RIESGO);
		coberturas.put("75" ,CoberturasEnum.TODO_RIESGO);
		coberturas.put("76" ,CoberturasEnum.TERCEROS_COMPLETOS_FULL);
		coberturas.put("72" ,CoberturasEnum.TERCEROS_COPMLETOS);
		try {
			CotizacionFullType[] cotizacion=null;
			CotizacionVehiculoEBSBindingQSServiceLocator locator = new CotizacionVehiculoEBSBindingQSServiceLocator();


			CalcularCotizacionFullVehiculoResponseEBMType wsResponse = locator.getCotizacionVehiculoEBSBindingQSPort().calcularCotizacionFullVehiculo(calcularCotizacionFullVehiculoEBM);
			if (wsResponse.getDataArea()!=null){
				cotizacion = wsResponse.getDataArea().getCalcularCotizacionFullVehiculoResponse().getListaCotizacionFull();
				
				/*Para ver todo lo que devuelve
				for (int i = 0; i<cotizacion.length; i++){
					System.out.println(cotizacion[i].getCodigoDeCobertura() + " " + cotizacion[i].getDescripcionDeCobertura() + " " + cotizacion[i].getPremio().getImportePremio());
				}
				*/
				
				String codCobertura;
				for (CotizacionFullType cotizacionFullType : cotizacion) {
					codCobertura = cotizacionFullType.getCodigoDeCobertura();
					CoberturasEnum cobertura = coberturas.get(codCobertura);
					if (cobertura!=null){
						switch (cobertura) {
						case RESPONSABILIDAD_CIVIL:
							response.setRc(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						case TERCEROS_COMPLETOS_FULL:
							response.setTcf(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						case TERCEROS_COMPLETOS_FULL_GRANIZO:
							response.setTcfg(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						case TERCEROS_COPMLETOS:
							response.setTc(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						case TODO_RIESGO:
							response.setTr(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						case TOTAL_SIN_DANOS_PARCIALES:
							response.setTt(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						}
					}else
						log.error("La cobertura codigo: " + codCobertura + " no tiene cobertura asociada.");
				}
				
				//Arreglo granizo
				if (response.getTcf()!=0 && response.getTr()!=0){
					response.setTcfg( (response.getTcf() + response.getTr() )/2);
				}
				
				//Comienzo 2do pedido con granizo
				/*
				AdicionalType adicionalGranizo = new AdicionalType("001", new BigDecimal(1000));
				AdicionalType [] listaAdicionales2 =  {adicionalGranizo};
				listaAdicionales2[0]=adicionalGranizo;
				dataArea.getCalcularCotizacionFullVehiculo().setListaAdicionales(listaAdicionales2);
				wsResponse = locator.getCotizacionVehiculoEBSBindingQSPort().calcularCotizacionFullVehiculo(calcularCotizacionFullVehiculoEBM);
				cotizacion = wsResponse.getDataArea().getCalcularCotizacionFullVehiculoResponse().getListaCotizacionFull();

				coberturas.remove("35");
				coberturas.remove("76");
				coberturas.put("35" ,CoberturasEnum.TERCEROS_COMPLETOS_FULL_GRANIZO);
				coberturas.put("76" ,CoberturasEnum.TERCEROS_COMPLETOS_FULL_GRANIZO);
				//se hace el mismo for nada mas que se pisan las tres que corresponden con granizo
				for (CotizacionFullType cotizacionFullType : cotizacion) {
					codCobertura = cotizacionFullType.getCodigoDeCobertura();
					CoberturasEnum cobertura = coberturas.get(codCobertura);
					if (cobertura!=null){
						switch (cobertura) {
						case TERCEROS_COMPLETOS_FULL_GRANIZO:
							response.setTcfg(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						case TERCEROS_COPMLETOS:
							response.setTc(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						case TODO_RIESGO:
							response.setTr(cotizacionFullType.getPremio().getImportePremio().intValue());
							break;
						}

					}
				}
				*/
				//Fin 2da peticion
				
				/**
				AdicionalType adicionalGranizo = new AdicionalType("001", new BigDecimal(1000));
				AdicionalType [] listaAdicionales2 =  {adicionalGranizo,adicionalGranizo};
				
				String codigoDeCobertura = "76";
				String codigoDeProducto = "53";
				String franquiciaTodoRiesgo= "";
				ProductoType producto = new ProductoType(codigoDeCobertura, codigoDeProducto, franquiciaTodoRiesgo, listaAdicionales2);
				CalcularCotizacionVehiculoType calcularCotizacionVehiculo = new CalcularCotizacionVehiculoType(codigoDeProductor, vehiculoACotizar, condicionesContratacion, producto , ubicacionDelRiesgo);
				CalcularCotizacionVehiculoDataAreaType dataArea2 = new CalcularCotizacionVehiculoDataAreaType(calcularCotizacionVehiculo );
				CalcularCotizacionVehiculoEBMType cotizacion2 = new CalcularCotizacionVehiculoEBMType(EBMHeader, dataArea2);
				CalcularCotizacionVehiculoResponseEBMType wsResponse2 = locator.getCotizacionVehiculoEBSBindingQSPort().calcularCotizacionVehiculo(cotizacion2);
				System.out.println(wsResponse2.getErrorCode());
				*/
			
			}else{
				log.error(wsResponse.getReturnMessage());
			}
		} catch (RemoteException e) {
			log.error(e.getMessage());
			e.printStackTrace();
		} catch (ServiceException e) {
			log.error(e.getMessage());
			e.printStackTrace();
		}

		return response;

	}
}
